package rocks.zipcode;

import java.io.*;
import java.nio.file.Files;
import java.util.Arrays;
import java.util.List;

/**
 * @author leon on 16/11/2018.
 */
public class Document implements DocumentInterface {

    private final FileWriter fileWriter;
    private final File file;

    public Document(String fileName) throws IOException {
        this(new File(fileName));
    }

    public Document(File file) throws IOException {
        this.file = file;
        this.fileWriter = new FileWriter(file);
    }

    @Override
    public void write(String contentToBeWritten) {
        try {
            BufferedWriter br = new BufferedWriter(new FileWriter(file));
            br.write(contentToBeWritten);
            br.close();

        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    @Override
    public void write(Integer lineNumber, String valueToBeWritten) {
        String [] reads = read().split("\n");
        reads[lineNumber] = valueToBeWritten;
        String newF = "";
        for (String words : reads) {
            newF += words + "\n";
        }
        write(newF.trim());
    }

    @Override
    public String read(Integer lineNumber) {
        try {
            BufferedReader br = new BufferedReader(new FileReader(file));
            String lines = "";
            for (int i = 0; i <= lineNumber; i++) {
                lines = br.readLine();
            }
            br.close();
            return lines;
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String read() {
        try {
            BufferedReader br = new BufferedReader(new FileReader(file));
            StringBuilder files = new StringBuilder();
            String line;
            while ((line = br.readLine()) != null) {
                files.append(line).append("\n");
            }
            br.close();
            return files.toString().trim();
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public void replaceAll(String stringToReplace, String replacementString) {
        String newbie = read().replaceAll(stringToReplace, replacementString);
        write(newbie);
    }

    @Override
    public void overWrite(String content) {
        write(content);
    }

    public List<String> toList() {
        return Arrays.asList(read().split("\n"));
    }

    @Override
    public File getFile() {
        return file;
    }

    @Override
    public String toString() {
        return file + "{" + read() +"}";
    }
}
